// ConaitoVoIP.h: interface for the CConaitoVoIP class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONAITOVOIP_H__BD61051F_F5A2_420D_9813_2F1ABE03CDE3__INCLUDED_)
#define AFX_CONAITOVOIP_H__BD61051F_F5A2_420D_9813_2F1ABE03CDE3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CConaito;

class CConaitoVoIP  
{
private:

	CConaito* m_pConaito;

public:
	CConaitoVoIP();
	~CConaitoVoIP();

public:

	
	BOOL Initialize(UINT nReceivePort);
	void UnInitialize();
	
	BOOL RegisterToProxy(CString sUniqueId, CString sProxyIP, UINT nProxyPort, CString sParam1, CString sParam2, CString sParam3, CString sParam4, CString sParam5, CString sLocalIP, UINT nLocalPort, DWORD dwTimeOut);
	BOOL UnRegisterToProxy();
	
	DWORD GetProxyParamValueReturned();
	CString GetStringParamValueReturned();

	CString GetConversationUniqueIdAt(int nPosition);
	
	BOOL RegisterToProxyDone();
		
	BOOL Connect(CString sToUniqueId, DWORD dwTimeOut);
	BOOL Disconnect();
	
	BOOL SetSpkVolume(int nVolume);
	int GetSpkVolume();
	
	BOOL SetMicVolume(int nVolume);
	int GetMicVolume();

	BOOL EnableMicBoost();
	BOOL DisableMicBoost();
	int GetMicBoost();

	BOOL AcceptIncomingCall(CString sUniqueId, DWORD dwTimeOut);
	BOOL CancelIncomingCall(CString sUniqueId);
	
	BOOL SendTxtMsgToAllInConversation(CString sTextMsg);
	BOOL SendTxtMsgDirect(CString sFromUniqueId, CString sIP, DWORD nPort, CString sTextMsg);
	BOOL SendTxtMsgThroughProxy(CString sFromUniqueId, CString sToProxyRegisteredUniqueId, CString sProxyIP, UINT nProxyPort, CString sTextMsg);
	BOOL SendTxtMsgToServer(CString sTextMsg);

	BOOL SendWhisper(CString sUniqueId, CString sTextMsg);
	
	DWORD GetLastError();
		
	BOOL SetLicenceKey(CString sLicenceKey);

	void DisableBusyState();
	void EnableBusyState();

	void DisableNotAvailableState();
	void EnableNotAvailableState();

	BOOL MuteMic(BOOL bMute);
	BOOL MuteSpk(BOOL bMute);

	DWORD GetOutBoundTotalBytes();
	DWORD GetInBoundTotalBytes();
	DWORD GetOutBoundDataRate();
	DWORD GetInBoundDataRate();
	
	BOOL AddConf(CString sUniqueId, DWORD dwTimeOut);
	BOOL AcceptAddConfRequest(CString sUniqueId, DWORD dwTimeOut);
	BOOL CancelAddConfRequest(CString sUniqueId);

	virtual void OnStatusEvent(DWORD dwStatusCode, CString sFromUniqueId);
	virtual void OnTextEvent(CString sTextMsg, CString sFromUniqueId);
	virtual void OnServerTextEvent(CString sTextMsg);
	virtual void OnWhisperEvent(CString sUniqueId, CString sTextMsg);
	virtual void OnConnectionEvent(CString sFromUniqueId);
	virtual void OnAddConferenceEvent(CString sFromUniqueId);

};

#endif // !defined(AFX_CONAITOVOIP_H__BD61051F_F5A2_420D_9813_2F1ABE03CDE3__INCLUDED_)
