// ConaitoProxyServer.h: interface for the CConaitoProxyServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONAITOPROXYSERVER_H__641FE420_29AE_4BD8_B267_1B5AF3DF7B00__INCLUDED_)
#define AFX_CONAITOPROXYSERVER_H__641FE420_29AE_4BD8_B267_1B5AF3DF7B00__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CConaito;

class CConaitoProxyServer  
{

public:
	CConaitoProxyServer();
	~CConaitoProxyServer();


private:

	CConaito* m_pConaitoProxy;


public:

	BOOL Initialize(UINT nReceivePort);
	void UnInitialize();
	DWORD GetLastError();

	CString GetRegisteredClientRemoteIP(CString sUniqueId);
	UINT GetRegisteredClientRemotePort(CString sUniqueId);

	CString GetRegisteredClientLocalIP(CString sUniqueId);
	UINT GetRegisteredClientLocalPort(CString sUniqueId);

	CString GetRegisteredClientParam1(CString sUniqueId);
	CString GetRegisteredClientParam2(CString sUniqueId);
	CString GetRegisteredClientParam3(CString sUniqueId);
	CString GetRegisteredClientParam4(CString sUniqueId);
	CString GetRegisteredClientParam5(CString sUniqueId);

	DWORD GetOutBoundTotalBytes();
	DWORD GetInBoundTotalBytes();
	DWORD GetOutBoundDataRate();
	DWORD GetInBoundDataRate();
	
	DWORD GetTotalRegisteredClient();
	CString GetRegisteredClientAt(int nPosition);

	BOOL SendTextMessageTo(CString sUniqueId, CString sTextMsg);
	BOOL SendTextMessageToAll(CString sTextMsg);
		
	BOOL SendParamValueReturned(DWORD dwParamValueReturned, CString sParam, CString sIPFrom, UINT nPortFrom);
	BOOL RegistrationDone(CString sUniqueId, CString sParam1,CString sParam2,CString sParam3,CString sParam4, CString sParam5, CString sFromIP, UINT nFromPort, CString sLocalIP, UINT nLocalPort);

	BOOL SetVoiceStreamIPPort(DWORD dwEventHandle, CString sVoiceIP, UINT nVoicePort);
	BOOL SetVoiceStreamThroughProxy(DWORD dwEventHandle);

	virtual void OnRegisteration(CString sUniqueId, CString sParam1,CString sParam2,CString sParam3,CString sParam4, CString sParam5, CString sFromIP, UINT nFromPort, CString sLocalIP, UINT nLocalPort);
	virtual void OnUnRegisteration(CString sUniqueId);
	virtual void OnConnectionLost(CString sUniqueId);
	virtual void OnServerTextMsg(CString sFromUniqueId, CString sTextMsg);
	virtual void OnTextMsg(CString sFromUniqueId, CString sToUniqueId, CString sTextMsg);
	
	virtual void OnConversationConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId);
	virtual void OnConversationAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId);
	virtual void OnConferenceConnected(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId);
	virtual void OnConferenceAccepted(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId);
	virtual void OnAddConference(DWORD dwEventHandle, CString sFromUniqueId, CString sToUniqueId, CString sAddConfUniqueId);
	

};



#endif // !defined(AFX_CONAITOPROXYSERVER_H__641FE420_29AE_4BD8_B267_1B5AF3DF7B00__INCLUDED_)
